# SplittablesBase: a simple API for parallel computation on collections

[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliafolds.github.io/SplittablesBase.jl/dev)
[![GitHub Actions](https://github.com/JuliaFolds/SplittablesBase.jl/workflows/Run%20tests/badge.svg)](https://github.com/JuliaFolds/SplittablesBase.jl/actions?query=workflow%3A%22Run+tests%22)

SplittablesBase.jl defines a simple set of APIs:

* `halve(collection)`: splitting given `collection` roughly in half.
* `amount(collection)`: an "approximation" of `length`.

These are the basis of parallel algorithms that can be derived from
`reduce`.  Custom containers can support many parallel algorithms by
simply defining these functions.

[SplittablesTesting.jl](https://github.com/JuliaFolds/SplittablesTesting.jl)
provides simple test utility functions
`SplittablesTesting.test_ordered(examples)` and
`SplittablesTesting.test_unordered(examples)` that run some
automatable tests with each example container in `examples`.

See more in the
[documentation](https://juliafolds.github.io/SplittablesBase.jl/dev).

## Supported collections

`halve` methods for following collections in `Base` are implemented in
SplittablesBase.jl:

* `AbstractArray`
* `AbstractString`
* `Dict`
* `keys(::Dict)`
* `values(::Dict)`
* `Set`
* `Tuple`
* `NamedTuple`
* `zip`
* `pairs`
* `Base.Generator`
* `Iterators.filter`
* `Iterators.flatten`
* `Iterators.partition`
* `Iterators.product`
* `Iterators.enumerate`
* `Iterators.reverse`
* `skipmissing`

## Packages using SplittablesBase.jl

* [Transducers.jl](https://github.com/JuliaFolds/Transducers.jl)
* [FLoops.jl](https://github.com/JuliaFolds/FLoops.jl)
* [ThreadsX.jl](https://github.com/tkf/ThreadsX.jl)

## See also

* [`Spliterator<T> trySplit()` (Java)](https://docs.oracle.com/en/java/javase/13/docs/api/java.base/java/util/Spliterator.html)

module TestUI

using Base.Iterators: partition
using SplittablesBase: halve
using SplittablesBase.Implementations: shape
using Test

macro expect(T, ex)
    quote
        local err
        err = try
            $(esc(ex))
            nothing
        catch err
            err isa $(esc(T)) || rethrow()
            Some(err)
        end
        err === nothing && error("exception not thrown")
        something(err)
    end
end

@testset "zip" begin
    err = @expect ArgumentError halve(zip(1:3, 1:4))
    msg = sprint(showerror, err)
    @test occursin("`halve(zip(...))` requires collections with identical `size`", msg)

    err = @expect MethodError halve(zip(1:3, "abc"))
    @test err.f === shape

    if !isdefined(Iterators, :Zip1)  # VERSION >= v"1.1-"
        err = @expect ArgumentError halve(zip())
        msg = sprint(showerror, err)
        @test occursin("empty `zip` does not have `size`", msg)
    end
end

end  # module

baremodule SplittablesBase

function halve end
function amount end

module Implementations
import ..SplittablesBase: SplittablesBase, amount, halve
using Base: KeySet, ValueIterator
using Setfield: @set
include("implementations.jl")
end  # module

module Testing
using Test: @test, @testset
using ..SplittablesBase: amount, halve
include("testing.jl")
end  # module

end # module

module TestPartition

using Base.Iterators: partition
using SplittablesBase: halve
using Test

@testset "left is always complete" begin
    @testset for len in 1:10, p in 1:len
        left, = halve(partition(1:len, p))
        @test unique(map(length, left)) == [p]
    end
end

end  # module

module TestWithOffset

using Base: HasEltype, HasLength, HasShape, IteratorEltype, IteratorSize
using SplittablesBase.Implementations: WithOffset
using Test

@testset "eltype" begin
    @test IteratorEltype(WithOffset(1:2, 0)) isa HasEltype
    @test eltype(WithOffset(1:2, Int128(0))) === Int128
end

@testset "size" begin
    xs = eachindex("abc")
    @test IteratorSize(WithOffset(xs, 1)) isa HasLength
    @test length(WithOffset(xs, 1)) == 3
    @test collect(WithOffset(xs, 1)) == xs .+ 1
end

@testset "size" begin
    xs = reshape(1:6, 2, 3)
    @test IteratorSize(WithOffset(xs, 0)) isa HasShape
    @test size(WithOffset(xs, 1)) == (2, 3)
    @test length(WithOffset(xs, 1)) == 6
    @test collect(WithOffset(xs, 1)) == xs .+ 1
end

end  # module

# Load docstring from markdown files:
for (name, path) in [:test_ordered => joinpath(@__DIR__, "test_ordered.md")]
    try
        include_dependency(path)
        str = read(path, String)
        @eval @doc $str $name
    catch err
        @error "Failed to import docstring for $name" exception = (err, catch_backtrace())
    end
end

function getlabel(x)
    i, example = x
    if example isa NamedTuple
        return example.label
    else
        return "$i"
    end
end

function getdata(x)
    i, example = x
    if example isa NamedTuple
        return example.data
    else
        return example
    end
end

const RECURSION_LIMIT = Ref(1000)

struct RecursionLimitError <: Exception
    f
    args::Tuple
    kwargs::NamedTuple
end

RecursionLimitError(f, args) = RecursionLimitError(f, args, NamedTuple())

function Base.showerror(io::IO, err::RecursionLimitError)
    println(io, "RecursionLimitError")
    print(io, "f = ", err.f)
    for (i, a) in enumerate(err.args)
        println(io)
        print(io, "args[$i] = ")
        show(io, "text/plain", a)
    end
    for (k, v) in pairs(err.kwargs)
        println(io)
        print(io, "kargs.$k = ")
        show(io, "text/plain", v)
    end
end

"""
    recursive_vcat(splittable_iterator, [amount]; recursion_limit)

Recursively call `halve` and `vcat`.  This should be equivalent to
`collect(splittable_iterator)` for ordered iterators.

The second argument is used for computing the length of an iterator.
By default [`amount`](@ref) is used.  If `length` is defined, passing
`length` should also work.
"""
recursive_vcat(data, _len = amount; recursion_limit = RECURSION_LIMIT[]) = recursive_vcat(
    data,
    _len,
    0,
    recursion_limit,
    RecursionLimitError(recursive_vcat, (data, _len), (recursion_limit = recursion_limit,)),
)

function recursive_vcat(data, _len, recursions, limit, err)
    recursions += 1
    recursions > limit && throw(err)
    _len(data) < 2 && return vec(collect(data))
    left, right = halve(data)
    @debug "recursive_vcat(data, $length)" _len(left) _len(right) data left right
    return vcat(
        recursive_vcat(left, _len, recursions, limit, err),
        recursive_vcat(right, _len, recursions, limit, err),
    )
end

function test_recursive_halving(x)
    @debug "Testing _recursive halving_: $(getlabel(x))"
    @testset "recursive halving" begin
        if Base.IteratorSize(getdata(x)) isa Union{Base.HasLength,Base.HasShape}
            @test isequal(recursive_vcat(getdata(x), length), vec(collect(getdata(x))))
        end
        @test isequal(recursive_vcat(getdata(x)), vec(collect(getdata(x))))
    end
end

function test_ordered(examples)
    @testset "$(getlabel(x))" for x in enumerate(examples)
        @debug "Testing `vcat`: $(getlabel(x))"
        @testset "vcat" begin
            data = getdata(x)
            left, right = halve(getdata(x))
            @test isequal(
                vcat(vec(collect(left)), vec(collect(right))),
                vec(collect(getdata(x))),
            )
        end
        test_recursive_halving(x)
    end
end

@deprecate test test_ordered false

function countmap(xs)
    counts = Dict{Any,Int}()
    for x in xs
        counts[x] = get(counts, x, 0) + 1
    end
    return counts
end

"""
    SplittablesTesting.test_unordered(examples)

See [`test_ordered`](@ref Main.SplittablesTesting.test_ordered).
"""
function test_unordered(examples)
    @testset "$(getlabel(x))" for x in enumerate(examples)
        @testset "concatenation" begin
            data = getdata(x)
            left, right = halve(getdata(x))
            @test isequal(
                countmap(collect(data)),
                merge(+, countmap(collect(left)), countmap(collect(right))),
            )
        end
        test_recursive_halving(x)
    end
end

const _PUBLIC_API = [
    # A list of public APIs to be picked by SplittablesTesting.jl
    :test_ordered,
    :test_unordered,
]

using Documenter, SplittablesBase, SplittablesTesting

makedocs(;
    modules=[SplittablesBase, SplittablesTesting],
    format=Documenter.HTML(),
    pages=[
        "Home" => "index.md",
    ],
    repo="https://github.com/JuliaFolds/SplittablesBase.jl/blob/{commit}{path}#L{line}",
    sitename="SplittablesBase.jl",
    authors="Takafumi Arakaki <aka.tkf@gmail.com>",
)

deploydocs(;
    repo="github.com/JuliaFolds/SplittablesBase.jl",
    push_preview=true,
)

module TestUnordered

import SplittablesBase

raw_examples = dict_examples = """
Dict{Symbol,Int}()
Dict(:a => 1)
Dict(:a => 1, :b => 2)
Dict(:a => 1, :b => 2, :c => 3)
Dict(:a => 1, :b => 2, :c => 3, :d => 4)
Dict(:a => 1, :b => 2, :c => 3, :d => 4, :e => 5)
Dict(zip('a':'z', 1:26))
"""

function wrapdict(f)
    lines = map(split(dict_examples, "\n", keepempty = false)) do code
        "$f($code)"
    end
    return join(lines, "\n") * "\n"
end

raw_examples *= wrapdict("keys") * wrapdict("values")

raw_examples *= """
Set(1:0)
Set(1:1)
Set(1:2)
Set(1:3)
Set(1:4)
Set(1:5)
Set(1:100)
"""

# An array of `(label = ..., data = ...)`
examples = map(split(raw_examples, "\n", keepempty = false)) do code
    (label = code, data = Base.include_string(@__MODULE__, code))
end

SplittablesBase.Testing.test_unordered(examples)

end  # module

module TestRecursionLimitError

using SplittablesBase
using SplittablesBase.Testing: RecursionLimitError
using Test

struct BrokenSplittable end

Base.iterate(::BrokenSplittable, n = 1) = n > 3 ? nothing : (n, n + 1)
Base.eltype(::Type{BrokenSplittable}) = Int
Base.length(::BrokenSplittable) = 3

# Invalid definition:
SplittablesBase.halve(::BrokenSplittable) = (BrokenSplittable(), ())

@testset begin
    # Make sure it's OK as an iterable:
    @test collect(BrokenSplittable()) == 1:3

    err = try
        SplittablesBase.Testing.recursive_vcat(BrokenSplittable())
        nothing
    catch err
        err
    end
    @test err isa RecursionLimitError
    msg = sprint(showerror, err)
    @debug "Testing an error from `recursive_vcat(BrokenSplittable())`" Text(msg)
    @test occursin("RecursionLimitError", msg)
    @test occursin("BrokenSplittable", msg)
end

@testset "smoke tests" begin
    @test sprint(showerror, RecursionLimitError(identity, ())) isa AbstractString
    @test sprint(showerror, RecursionLimitError(identity, (1,))) isa AbstractString
    @test sprint(showerror, RecursionLimitError(identity, (), (a = 1,))) isa AbstractString
    @test sprint(showerror, RecursionLimitError(identity, (1,), (a = 1,))) isa
          AbstractString
end

end  # module

module TestDoctest

import SplittablesBase
using Documenter: doctest
using Test

@testset "doctest" begin
    if lowercase(get(ENV, "JULIA_PKGEVAL", "false")) == "true"
        @info "Skipping doctests on PkgEval."
        return
    end
    doctest(SplittablesBase)
end

end  # module

# Load docstring from markdown files:
for (name, path) in [
    :SplittablesBase => joinpath(dirname(@__DIR__), "README.md"),
    :halve => joinpath(@__DIR__, "halve.md"),
    :amount => joinpath(@__DIR__, "amount.md"),
]
    try
        include_dependency(path)
        str = read(path, String)
        @eval @doc $str $name
    catch err
        @error "Failed to import docstring for $name" exception = (err, catch_backtrace())
    end
end

"""
    _unzip(xs::Tuple)

# Examples
```jldoctest; setup = :(using SplittablesBase.Implementations: _unzip)
julia> _unzip(((1, 2, 3), (4, 5, 6)))
((1, 4), (2, 5), (3, 6))
```
"""
_unzip(xs::Tuple{Vararg{NTuple{N,Any}}}) where {N} = ntuple(i -> map(x -> x[i], xs), N)

tail(xs) = _tail(xs...)
_tail(_, args...) = args

"""
    arguments(xs)

An "inverse" of a factory function.  It returns a tuple s.t.

```
args == arguments(f(args...))
```

where `f` is `zip`, `Base.Generator`, `Iterators.filter`, etc.
"""
function arguments end

if isdefined(Iterators, :Zip1)  # VERSION < v"1.1-"
    arguments(xs::Iterators.Zip1) = (xs.a,)
    arguments(xs::Iterators.Zip2) = (xs.a, xs.b)
    arguments(xs::Iterators.Zip) = (xs.a, arguments(xs.z)...)
else
    arguments(xs::Iterators.Zip) = xs.is
end
if isdefined(Iterators, :AbstractZipIterator)  # VERSION < v"1.1-"
    const _Zip = Iterators.AbstractZipIterator
else
    const _Zip = Iterators.Zip
end

arguments(xs::Base.Generator) = (xs.f, xs.iter)
arguments(xs::Iterators.Filter) = (xs.flt, xs.itr)
arguments(xs::Iterators.Flatten) = (xs.it,)
arguments(xs::Iterators.PartitionIterator) = (xs.c, xs.n)
arguments(xs::Base.SkipMissing) = (xs.x,)

safelength(xs) =
    Base.IteratorSize(xs) isa Union{Base.HasLength,Base.HasShape} ? length(xs) : nothing

amount(xs) = length(xs)
amount(xs::AbstractString) = lastindex(xs) - firstindex(xs) + 1
amount(xs::Base.EachStringIndex) = amount(xs.s)

struct WithOffset{Iter,Offset}
    iter::Iter
    offset::Offset
end

withoffset(iter, offset) = WithOffset(iter, offset)
withoffset(iter::WithOffset, offset) = WithOffset(iter.iter, iter.offset + offset)

_shift(wo, ::Nothing) = nothing
_shift(wo, (i, s)) = (convert(eltype(wo), wo.offset + i), s)
Base.iterate(wo::WithOffset) = _shift(wo, iterate(wo.iter))
Base.iterate(wo::WithOffset, s) = _shift(wo, iterate(wo.iter, s))

Base.IteratorEltype(::Type{<:WithOffset{Iter}}) where {Iter} =
    Base.IteratorEltype(Iter)
Base.IteratorSize(::Type{<:WithOffset{Iter}}) where {Iter} =
    Base.IteratorSize(Iter)
Base.eltype(::Type{WithOffset{Iter,Offset}}) where {Iter,Offset} =
    promote_type(eltype(Iter), Offset)
Base.length(wo::WithOffset) = length(wo.iter)
Base.size(wo::WithOffset) = size(wo.iter)
amount(wo::WithOffset) = amount(wo.offset)

function halve(xs::AbstractVector)
    mid = length(xs) ÷ 2
    left = @view xs[firstindex(xs):firstindex(xs)-1+mid]
    right = @view xs[firstindex(xs)+mid:end]
    return (left, right)
end

function halve(xs::AbstractArray)
    i = something(findlast(x -> x > 1, size(xs)), 1)
    mid = size(xs, i) ÷ 2
    leftranges = ntuple(ndims(xs)) do j
        if i == j
            firstindex(xs, j):firstindex(xs, j) + mid - 1
        else
            firstindex(xs, j):lastindex(xs, j)
        end
    end
    rightranges = ntuple(ndims(xs)) do j
        if i == j
            firstindex(xs, j) + mid:lastindex(xs, j)
        else
            firstindex(xs, j):lastindex(xs, j)
        end
    end
    return (view(xs, leftranges...), view(xs, rightranges...))
end

halve(xs::AbstractArray{<:Any,0}) = ((), xs)

# A view wrapper returned from `halve` on `Dict`, `keys`, `values`, and `Set`.
struct DictView{D,F}
    dict::D
    firstslot::Int
    lastslot::Int
    f::F  # identity, first, or last
end

DictView(xs::DictView, i::Int, j::Int) = DictView(xs.dict, i, j, xs.f)

Base.IteratorEltype(::Type{<:DictView{D}}) where {D} = Base.IteratorEltype(D)
Base.IteratorSize(::Type{<:DictView}) = Base.SizeUnknown()

Base.eltype(::Type{<:DictView{D,typeof(identity)}}) where {D} = eltype(D)
Base.eltype(::Type{<:DictView{D,typeof(first)}}) where {D} = keytype(D)
Base.eltype(::Type{<:DictView{D,typeof(last)}}) where {D} = valtype(D)

const DictWrapper = Union{Set,KeySet,ValueIterator}
const DictLike = Union{Dict,DictView,DictWrapper}

DictView(xs::AbstractDict, i::Int, j::Int) = DictView(xs, i, j, identity)
DictView(xs::Union{KeySet,Set}, i::Int, j::Int) = DictView(xs.dict, i, j, first)
DictView(xs::ValueIterator, i::Int, j::Int) = DictView(xs.dict, i, j, last)

# Note: this relies on the implementation detail of `iterate(::Dict)`.
@inline function Base.iterate(xs::DictView, i = xs.firstslot)
    i <= xs.lastslot || return nothing
    y = iterate(xs.dict, i)
    y === nothing && return nothing
    x, j = y
    # If `j` is `xs.lastslot + 1` or smaller, it means the current element is
    # within the range of this `DictView`:
    j <= xs.lastslot + 1 && return xs.f(x), j
    # Otherwise, we need to stop:
    return nothing
end

function Base.length(xs::DictView)
    n = 0
    for _ in xs
        n += 1
    end
    return n
end

firstslot(xs::Dict) = xs.idxfloor
lastslot(xs::Dict) = lastindex(xs.slots)

firstslot(xs::DictView) = xs.firstslot
lastslot(xs::DictView) = xs.lastslot

firstslot(xs::DictWrapper) = firstslot(xs.dict)
lastslot(xs::DictWrapper) = lastslot(xs.dict)

amount(xs::DictLike) = lastslot(xs) - firstslot(xs) + 1

function halve(xs::DictLike)
    i1 = firstslot(xs)
    i3 = lastslot(xs)
    i2 = (i3 - i1 + 1) ÷ 2 + i1
    left = DictView(xs, i1, i2 - 1)
    right = DictView(xs, i2, i3)
    return (left, right)
end

function halve(xs::Iterators.Pairs)
    left, right = halve(keys(xs))
    return Iterators.Pairs(values(xs), left), Iterators.Pairs(values(xs), right)
end

function halve(xs::AbstractString)
    offset = firstindex(xs) - 1
    mid = thisind(xs, (lastindex(xs) - offset) ÷ 2 + offset)
    left = SubString(xs, firstindex(xs):mid)
    right = SubString(xs, nextind(xs, mid):lastindex(xs))
    return (left, right)
end

function halve(xs::Base.EachStringIndex)
    offset = firstindex(xs.s) - 1
    mid = thisind(xs.s, (lastindex(xs.s) - offset) ÷ 2 + offset)
    mid2 = nextind(xs.s, mid)
    left = eachindex(SubString(xs.s, firstindex(xs.s):mid))
    right = withoffset(eachindex(SubString(xs.s, mid2:lastindex(xs.s))), mid2 - 1)
    return (left, right)
end

function halve(xs::WithOffset{<:Base.EachStringIndex})
    left, right = halve(xs.iter)
    return withoffset(left, xs.offset), withoffset(right, xs.offset)
end

@generated function halve(xs::NTuple{N,Any}) where {N}
    m = N ÷ 2
    quote
        (($([:(xs[$i]) for i in 1:m]...),), ($([:(xs[$i]) for i in m+1:N]...),))
    end
end

@inline function halve(xs::NamedTuple{names}) where {names}
    lnames, rnames = halve(names)
    return NamedTuple{lnames}(xs), NamedTuple{rnames}(xs)
end

amount(xs::Base.Generator) = amount(arguments(xs)[2])

function halve(xs::Base.Generator)
    f, coll = arguments(xs)
    left, right = halve(coll)
    return Base.Generator(f, left), Base.Generator(f, right)
end

amount(xs::Iterators.Filter) = amount(arguments(xs)[2])

function halve(xs::Iterators.Filter)
    f, coll = arguments(xs)
    left, right = halve(coll)
    return Iterators.filter(f, left), Iterators.filter(f, right)
end

amount(xs::Iterators.Flatten) = amount(arguments(xs)[1])

function halve(xs::Iterators.Flatten)
    coll, = arguments(xs)
    left, right = halve(coll)
    return Iterators.flatten(left), Iterators.flatten(right)
    # return _flatten(left), _flatten(right)
end

# Is this better?
# _flatten(xs) = safelength(xs) == 1 ? first(xs) : Iterators.flatten(xs)

shape(xs::Union{AbstractArray,Broadcast.Broadcasted}) = size(xs)
shape(xs::Base.Generator) = size(arguments(xs)[2])
shape(xs::Union{NamedTuple,Tuple}) = (length(xs),)

# Make sure that `halve` on the collections give consistent result.
checkshape(xs::_Zip) = length(arguments(xs)) == 1 || shape(xs)
function shape(xs::_Zip)
    args = arguments(xs)
    length(args) == 0 && throw(ArgumentError("empty `zip` does not have `size`."))
    sizes = map(shape, args)
    if !all(==(sizes[1]), tail(sizes))
        throw(ArgumentError("`halve(zip(...))` requires collections with identical `size`"))
    end
    return sizes[1]
end

function halve(xs::_Zip)
    checkshape(xs)
    lefts, rights = _unzip(map(halve, arguments(xs)))
    return zip(lefts...), zip(rights...)
end

shape(xs::Iterators.ProductIterator) = map(length, xs.iterators)

function halve(product::Iterators.ProductIterator)
    i = findlast(x -> length(x) > 1, product.iterators)
    if i === nothing
        # It doesn't matter which "dimension" is used.
        left, right = halve(product.iterators[1])
    else
        left, right = halve(product.iterators[i])
    end
    return (@set(product.iterators[i] = left), @set(product.iterators[i] = right))
end

function shape(xs::Iterators.PartitionIterator)
    coll, = arguments(xs)
    shape(coll)  # make sure it has a shape
    return (length(xs),)
end

function halve(xs::Iterators.PartitionIterator)
    coll, n = arguments(xs)
    m = n * cld(div(length(coll), n), 2)
    offset = firstindex(coll) - 1
    return (
        Iterators.partition(view(coll, offset .+ (1:m)), n),
        Iterators.partition(view(coll, offset .+ (m+1:length(coll))), n),
    )
end

shape(xs::Iterators.Enumerate) = shape(xs.itr)

function halve(xs::Iterators.Enumerate)
    left, right = halve(xs.itr)
    return enumerate(left), zip(reshape(length(left)+1:length(xs), size(right)), right)
end

function halve(xs::Iterators.Reverse)
    left, right = halve(xs.itr)
    return Iterators.reverse(right), Iterators.reverse(left)
end

amount(xs::Base.SkipMissing) = amount(arguments(xs)[1])

function halve(xs::Base.SkipMissing)
    coll, = arguments(xs)
    left, right = halve(coll)
    return skipmissing(left), skipmissing(right)
end

module TestHalve

import SplittablesBase
using Base.Iterators: partition, product
using OffsetArrays: OffsetArray

raw_examples = """
1:10
1:11
[1:10;]
[1:11;]
reshape(1:6, 2, 3)
adjoint(reshape(1:6, 2, 3))
transpose(reshape(1:6, 2, 3))
permutedims(reshape(1:6, 2, 3))
permutedims(reshape(1:24, 2, 3, 4), (1, 2, 3))
permutedims(reshape(1:24, 2, 3, 4), (1, 3, 2))
permutedims(reshape(1:24, 2, 3, 4), (2, 1, 3))
permutedims(reshape(1:24, 2, 3, 4), (2, 3, 1))
permutedims(reshape(1:24, 2, 3, 4), (3, 1, 2))
permutedims(reshape(1:24, 2, 3, 4), (3, 2, 1))
OffsetArray(1:15, -1)
OffsetArray(reshape(1:15, 3, 5), -1:1, 0:4)
pairs(1:10)
pairs(1:11)
pairs(reshape(1:6, 2, 3))
pairs(adjoint(reshape(1:6, 2, 3)))
"abcde"
"abcdef"
"αβγδϵ"
"αβγδϵζ"
"あいうえお"
"あいうえおか"
"aいυe𝒐"
"aいυe𝒐か"
eachindex("abcde")
eachindex("abcdef")
eachindex("αβγδϵ")
eachindex("αβγδϵζ")
eachindex("あいうえお")
eachindex("あいうえおか")
eachindex("aいυe𝒐")
eachindex("aいυe𝒐か")
(1, 2, 3, 4, 5)
(1, 2, 3, 4, 5, 6)
(a=1, b=2, c=3, d=4, e=5)
(a=1, b=2, c=3, d=4, e=5, f=6)
zip(1:3, (11, 22, 33), (a=1, b=2, c=3))
(x^2 for x in 1:5)
(x^2 for x in 1:6)
(x^2 for x in 1:5 if isodd(x))
(x^2 for x in 1:6 if isodd(x))
Iterators.filter(isodd, 1:5)
Iterators.filter(isodd, 1:6)
Iterators.flatten([1:3, 4:5])
product(1:3, 1:4)
product(1:3, 1:4, 1:5)
product(pairs(1:10), pairs(1:11))
product(1:3, pairs(1:11), (1, 2), (a=1, b=2))
partition(1:10, 1)
partition(1:10, 2)
partition(1:10, 3)
partition(1:10, 4)
enumerate([11, 22, 33, 44])
enumerate([11, 22, 33, 44, 55])
enumerate(Iterators.product(1:3, 'a':'b'))
zip(1:3, partition(1:10, 4))
zip("αβγ")
zip(enumerate([11, 22, 33, 44]), 'a':'d')
zip(enumerate([11, 22, 33, 44, 55]), 'a':'e')
zip(Iterators.product(1:3, 'a':'b'), ones(3, 2))
Iterators.reverse(1:10)
Iterators.reverse(zip(1:3, 'a':'c'))
skipmissing([1, 2, missing, 4])
skipmissing([1, 2, missing, 4, 5])
"""

# An array of `(label = ..., data = ...)`
examples = map(split(raw_examples, "\n", keepempty = false)) do code
    (label = code, data = Base.include_string(@__MODULE__, code))
end

SplittablesBase.Testing.test_ordered(examples)

end  # module

    SplittablesBase.amount(collection) :: Int

Return the number of elements in `collection` or rough "estimate" of
it.

# Examples
```jldoctest
julia> using SplittablesBase: amount

julia> amount([1, 2, 3, 4])
4

julia> amount("aえ𝑖∅υ")
12

julia> length("aえ𝑖∅υ")  # != `amount`
5
```

Note that `amount` on strings is not equal to `length` because the
latter cannot be computed in O(1) time.

# Implementation

Implementations of `amount` on a collection must satisfy the following
laws.

(1) Any empty collection must have zero `amount`.

(2) Any operation that increments `length` on collection must
increments `amount`.

Ideally, the time-complexity of `amount` should be O(1).

    SplittablesTesting.test_ordered(examples)
    SplittablesTesting.test_unordered(examples)

Run interface tests on each test case in `examples`.

`examples` is an iterator where each element is either:

1. A container to be tested.

2. A `NamedTuple` with following keys

   * `:label`: A label used for `Test.@testcase`.
   * `:data`: A container to be tested.

# Examples
```julia
julia> using SplittablesBase

julia> SplittablesBase.Testing.test_ordered([
           (label = "First Test", data = 1:5),
           (label = "Second Test", data = (a = 1, b = 2, c = 3)),
           zip(1:3, 4:6),
       ]);
Test Summary: | Pass  Total
First Test    |    2      2
Test Summary: | Pass  Total
Second Test   |    2      2
Test Summary: | Pass  Total
3             |    2      2
```

    SplittablesBase.halve(collection) -> (left, right)

Split `collection` (roughly) in half.

# Examples
```jldoctest
julia> using SplittablesBase: halve

julia> halve([1, 2, 3, 4])
([1, 2], [3, 4])
```

# Implementation

Implementations of `halve` on custom collections must satisfy the
following laws.

(1) If the original collection is ordered, concatenating the
sub-collections returned by `halve` must create a collection that is
equivalent to the original collection.  More precisely,

```julia
isequal(
    vec(collect(collection)),
    vcat(vec(collect(left)), vec(collect(right))),
)
```

must hold.

Similar relationship must hold for unordered collections; i.e., taking
union of left and right collections as multiset must create a
collection that is equivalent to the original collection as a
multiset:

```julia
using StatsBase: countmap
isequal(
    countmap(collect(collection)),
    merge(+, countmap(collect(left)), countmap(collect(right))),
)
```

(2) `halve` must eventually shorten the collection.  More precisely,
the following function must terminate:

```julia
function recursive_halve(collection)
    length(collection) <= 1 && return
    left, right = halve(collection)
    recursive_halve(left)
    recursive_halve(right)
end
```

Furthermore, whenever implementable with cheap operations,
`length(left)` should be close to `length(collection) ÷ 2` as much as
possible.
